---
title: WebGLQuery
slug: Web/API/WebGLQuery
tags:
  - API
  - Experimental
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLQuery</code></strong> interface is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL 2</a> API and provides ways to asynchronously query for information. By default, occlusion queries and primitive queries are available.</p>

<p>Another kind of queries are disjoint timer queries, which allow you to measure performance and profiling of your GPU. Disjoint timer queries are available with the {{domxref("EXT_disjoint_timer_query")}} extension only.</p>

<p>When working with <code>WebGLQuery</code> objects, the following methods of the {{domxref("WebGL2RenderingContext")}} are useful:</p>

<ul>
 <li>{{domxref("WebGL2RenderingContext.createQuery()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.deleteQuery()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.isQuery()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.beginQuery()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.endQuery()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.getQuery()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.getQueryParameter()")}}</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_a_WebGLQuery_object">Creating a <code>WebGLQuery</code> object</h3>

<p>in this example, <code>gl</code> must be a {{domxref("WebGL2RenderingContext")}}. <code>WebGLQuery</code> objects are not available in WebGL 1.</p>

<pre class="brush: js notranslate">var query = gl.createQuery();
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.2", "WebGLQuery")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLQuery")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("EXT_disjoint_timer_query")}}</li>
</ul>
